/* Some prototypes for extern functions. */

#include <linux/types.h>	/* for __u16 */

#if !defined(__GNUC__) && !defined(__attribute__)
#define __attribute__(x)	/* if not using GCC, turn off the __attribute__
				   compiler-advice feature. */
#endif

/* identify() is the only extern function used across two source files.  The
   others, though, were declared in hdparm.c with global scope; since other
   functions in that file have static (file) scope, I assume the difference is
   intentional. */
extern void identify (__u16 *id_supplied, const char *devname);

extern void usage_error(int out)    __attribute__((noreturn));
extern int main(int argc, char **argv) __attribute__((noreturn));
extern void flush_buffer_cache (int fd);
extern int seek_to_zero (int fd);
extern int read_big_block (int fd, char *buf);
extern void time_cache (int fd);
extern void time_device (int fd);
extern void no_scsi (void);
extern void no_xt (void);
extern void process_dev (char *devname);

typedef unsigned char task_ioreg_t;

typedef union ide_reg_valid_s {
    unsigned all                : 16;
    struct {
        unsigned data           : 1;
        unsigned error_feature      : 1;
        unsigned sector         : 1;
        unsigned nsector        : 1;
        unsigned lcyl           : 1;
        unsigned hcyl           : 1;
        unsigned select         : 1;
        unsigned status_command     : 1;

        unsigned data_hob       : 1;
        unsigned error_feature_hob  : 1;
        unsigned sector_hob     : 1;
        unsigned nsector_hob        : 1;
        unsigned lcyl_hob       : 1;
        unsigned hcyl_hob       : 1;
        unsigned select_hob     : 1;
        unsigned control_hob        : 1;
    } b;
} ide_reg_valid_t;

typedef struct ide_task_request_s {
    task_ioreg_t    io_ports[8];
    task_ioreg_t    hob_ports[8];
    ide_reg_valid_t out_flags;
    ide_reg_valid_t in_flags;
    int     data_phase;
    int     req_cmd;
    unsigned long   out_size;
    unsigned long   in_size;
} ide_task_request_t;

typedef struct hd_drive_task_hdr {
    task_ioreg_t data;
    task_ioreg_t feature;
    task_ioreg_t sector_count;
    task_ioreg_t sector_number;
    task_ioreg_t low_cylinder;
    task_ioreg_t high_cylinder;
    task_ioreg_t device_head;
    task_ioreg_t command;
} task_struct_t;


#define IDE_DRIVE_TASK_OUT            3
#define __le16_to_cpus(x) do {} while (0)
